#!/usr/bin/perl -w
# -T can only be given on the command line (taint checking)
use strict; # homework by Eric Auer...
# task: find all text files in a directory and
# prepend each of them by a line containing the filename

my $thedir = "/tmp/ramdisk/eric";

sub changefile { # add the file name to the content of the file
                 # if the file is a text file
  my $who;
  ($who,$_) = @_; # copy arg, trash superfluous args
  if ((-f $who) && (-T $who)) {

    my $atime = 0;
    my $mtime;
    (undef, undef, undef, undef, undef, undef, undef, undef,
     $atime,$mtime,undef, undef, undef)  =  stat($who);
    # dev   ino    mode   nlink  uid    gid    rdev   size
    # atime mtime  ctime  blksz  blocks  (null list on fail)
    unless (defined $atime) {
      print STDERR
        "Cannot stat <". $who .">, file dates will change\n";
    }

    unless (open(TFILE,"<$who")) {
      print STDERR "Unreadable: $who\n";
      return -1;
    }
    my @contents = <TFILE>;
    close(TFILE);

    unshift(@contents,"# this is $who\n"); # add that name line

    unless (open(TFILE,">$who")) {
       print STDERR "Write error: $who\n";
       return -1;
    }
    print STDERR "Modifying: $who\n";
    foreach my $line (@contents) {
      chomp $line; # the file will end up having uniform \n ...
      print TFILE "$line\n"; # rewrite the file
    }
    close(TFILE);
    if ($atime) {
      utime $atime, $mtime, $who; # change file access/modify
                                  # time back to stored values
    }
  }
}

# main program:

unless (opendir(MYDIR,$thedir)) {
  print STDERR "Cannot read directory $thedir\n";
  die "Bailing out\n";
}

my @filelist = readdir(MYDIR);

closedir(MYDIR);

foreach my $afile (@filelist) {
  &changefile($afile);
}

