#!/usr/bin/perl -w
# -T can only be given on the command line (taint checking)
use strict; # homework by Eric Auer...
# task: use the perl find module to check all files in a
# directory tree for some property, and print a list...

use File::Find;
my %filelist;
my $PFAD = "../../../public_html/";

sub xprint {
#  print "" . $_[0] . ""; # redefine to no-op to avoid printing
                          # of the file list...
}

sub addhtml { # add to filelist if name ends in htm(l)
  my $who = $File::Find::name;
  if (-d $who) { print STDERR "Directory $who\n"; }
#  print "??? $who\n" if (!-f $who);
  if ((-f $who) && ($who =~ /[.]([sp])?htm(l)?$/)) {
    $filelist{$who} = 1;
  }
}

sub addascii { # add to filelist if ASCII test succeeds
  my $who = $File::Find::name;
  if (-d $who) { print STDERR "Directory $who\n"; }
  if ((-f $who) && (-T $who)) { $filelist{$who} = 1; }
}

sub addhtmleric { # add to filelist if name ends in htm(l) and
                  # Eric is found inside the file (no tag checking)
  my $who = $File::Find::name;
  if (-d $who) { print STDERR "Directory $who\n"; };
  if ( (-f $who) && ($who =~ /[.][sp]?html?$/) ) { 
    unless (open(FIL,"<$who")) { 
        print STDERR "Unreadable: $who\n";
        return;
    };
    my @what = <FIL>; # just read the file into an array
    close(FIL);
    my $words = join(" ",@what);
    if (lc($words) =~ /eric/) { $filelist{$who} = 1; }
    # else no Eric inside
  }
}

%filelist = ();
my $count = 0;
find(\&addhtml, $PFAD);
print "HTML files found:\n";
for (sort keys %filelist) { &xprint("$_\n"); $count++; };
print "$count HTML files found.\n\n";

%filelist = ();
$count = 0;
find(\&addascii, $PFAD);
print "ASCII files found:\n";
for (sort keys %filelist) { &xprint("$_\n"); $count++; };
print "$count ASCII files found.\n\n";

%filelist = ();
$count = 0;
find(\&addhtmleric, $PFAD);
print "HTML files with Eric inside found:\n";
for (sort keys %filelist) { &xprint("$_\n"); $count++; };
print "$count Eric HTML files found.\n\n";

