#!/usr/bin/perl -w
# -T can only be given on the command line (taint checking)
use strict; # homework by Eric Auer...

# Indexing over a set of HTML files
my $THERE = "."; # where to start in directory tree...

require "index-browse.pl";
require "index-demarkup.pl";

my %hsh;     # the big hash of hashes for the index
my @htmllist = split(":",&collecthtmlfiles($THERE));

foreach my $onefile (@htmllist) {

  my $content = &onthtml($onefile);

  $content =~ s/\W/ /gs;   # simplify "other": non-word -> " "
  $content =~ s/[\s\n][\s\n]+/ /gs;   # compress spaces and \n

  my $pos = 0;

  foreach my $oneword (split(" ",$content)) {
    $pos++; # we store the word numbers where the word occurs
    if (defined $hsh{$oneword}->{$onefile}) {
      # add one more reference to that word in that file
      $hsh{$oneword}->{$onefile} = 
        $hsh{$oneword}->{$onefile} . "," . $pos;
    } else {
      # create a new sub-hash for that word in that file
      $hsh{$oneword}->{$onefile} = $pos;
    }
  }
}

foreach my $oneword (sort keys %hsh) {
  printf "%20s: ", $oneword;
  foreach my $item (sort keys %{$hsh{$oneword}}) { # confusing,
                                                   # but works!
    print "<\"$item\"," . $hsh{$oneword}->{$item} . "> ";
  }
  print "\n";
}

