#!/usr/bin/perl -w
# -T can only be given on the command line (taint checking)
use strict; # homework by Eric Auer...

sub evenlang { # check for equal length of two arrays ref'd by args
               # or two string args (but mixed args are not allowed)
  my ($ref_a,$ref_b) = @_;	# copy args
  if ((ref $ref_a) ne (ref $ref_b)) {
    print "Mixed argument types in evenlang: "
      . ((ref $ref_a) ? ("reference to " . (ref $ref_a)) : "scalar")
      . " and "
      . ((ref $ref_b) ? ("reference to " . (ref $ref_b)) : "scalar")
      . "\n";
    return 0; # false
  };
  if (!(ref $ref_a)) { # ""if it is no reference, it is a scalar""
    return (length($ref_a) == length($ref_b));
  } # else: array refs
  return ( @$ref_a == @$ref_b ); # scalar context of == leads to
                                 # comparing the numbers of elements
}

my @a = qw/foo bar baz/;
my @b = qw/aap noot mies/;
my @c = qw/n w s e/;

print "Is <@a> as long as <@b> ? "
  . ((&evenlang(\@a,\@b)) ? "yes" : "no") . "!\n";

print "Is <@a> as long as <@c> ? "
  . ((&evenlang(\@a,\@c)) ? "yes" : "no") . "!\n";

print "Is foo as long as bar ? "
  . ((&evenlang("foo","bar")) ? "yes" : "no") . "!\n";

print "Is foo as long as maria ? "
  . ((&evenlang("foo","maria")) ? "yes" : "no") . "!\n";

print "Is foo as long as <@a> ? "
  . ((&evenlang("foo",\@a)) ? "yes" : "no") . "!\n";

