#!/usr/bin/perl -w
# -T can only be given on the command line (taint checking)
use strict; # homework by Eric Auer...

sub printwrapped { # print a string arg2 with nice wrap to arg1 cols
  my ($cols,$text) = @_; # copy args
  if (length($text) <= $cols) { # simple case
    print "$text\n";
    return 1; # success
  }
  my $pos  = rindex($text," ",$cols);   # last acceptable space
  my $pos2 = rindex($text,"-",$cols);   # "-" also ok, if avail
  if ($pos2 > $pos) { $pos = $pos2; }; # the max
  if (($pos<1) || ($pos>$cols)) {
    print STDERR "Cannot wrap line to $cols cols ($pos): <$text>\n";
    print substr($text,0,$cols-3) . "...\n";
    return 0; # error
  }
  my $cut1 = $pos; # up to " " or "-" and including "-"...
  if ($pos2 == $pos) { $cut1++; } # ...because we do this
  my $cut2 = $pos+1; # after the " " or "-"
  print substr($text,0,$cut1) . "\n"; # one line
  $text = substr($text,$cut2);      # all the rest
  &printwrapped($cols,$text); # (tail-) recursion for the rest
  return 1; # success
}

sub formatteer { # print given array arg2 with a width of arg1
  my ($a,@b) =  @_; # copy args
  if ($a < 3) { print "too few columns to make sense\n"; return 0; };
  my $c;
  for $c (@b) { &printwrapped($a,$c); print "\n"; };
  return $c;
}

my @test = ("Once upon a time there was a strange little man",
            "He was called the wizard of Ooze,",
            "and got quite annoyed by always getting mixed up"
            . " with the wizard of Oz, who lived in Oz-land,"
            . " far away from Ooze-of-the-oozes-land." );

print "Een sprookje...\n\n";
&formatteer(15,@test);

