#!/usr/bin/perl -w
# -T can only be given on the command line (taint checking)
use strict; # homework by Eric Auer...

sub rom2arab { # convert a string with a roman numeral to a number
  my $a =  $_[0]; # copy arg
  if (!$a) { return 0; } # empty string
  $a = uc($a);
  if ($a =~ /[^IVXLCDM]/) { print "not a roman numeral\n"; return 0; }
  # assuming: IVXLCDM are 1 5 10 50 100 500 1000
  # tricky: the prefixing for -1. Example: I II III IV V ...
  my $num = 0;
  my $chr;
  $a =~ s/IV/IIII/g;
  $a =~ s/IX/IIIIIIIII/g;
  $a =~ s/XL/XXXX/g;
  $a =~ s/XC/XXXXXXXXX/g;
  $a =~ s/CD/CCCC/g;
  $a =~ s/CM/CCCCCCCCC/g;
  if (($a =~ /[IVXLCD].*M/) || ($a =~ /[IVXLC].*D/) ||
      ($a =~ /[IVXL].*C/)   || ($a =~ /[IVX].*L/)   ||
      ($a =~ /[IV].*X/)     || ($a =~ /I.*V/)) {
    print "This uses weird maths, not supported\n";
    return 0;
  }
  foreach $chr (split(//,$a)) { # now we can just add things
    if ($chr eq "I") { $num+=    1; }
    elsif ($chr eq "X") { $num+=   10; }
    elsif ($chr eq "C") { $num+=  100; }
    elsif ($chr eq "M") { $num+= 1000; }
    else { die "internal error in rom2arab\n"; };
  }
  return $num;  
}

print "MCMXCIX -> " . &rom2arab("MCMXCIX") . "\n";
print "XLII    -> " . &rom2arab("XLII") . "\n";

